//+------------------------------------------------------------------+
//|                                                       5minMA.mq4 |
//|                                                              I_D |
//|                                            http://www.mymmk.com/ |
//+------------------------------------------------------------------+
#property copyright "I_D"
#property link      "http://www.mymmk.com/    "

#define           magic 3904900

extern int        iSl = 6; //    (., 6)
extern int        iToBE = 6; //   ,       (., 6)
extern int        iTP = 10; //    (., 10)
extern int        iSMA50Diff = 3; // -  ()  SMA50,     
extern double     dAngleMACritical = 15; //   SMA21   ,     
extern int        iIndent = 1; //       
extern double     dLot = 0.1; //  

//+------------------------------------------------------------------+
//|   http://strateg.org.ua/tactics/070407.php                 |
//|    50SMA, 21EMA & 10EMA;   -  |
//|  50SMA     21EMA.     |
//| (21EMA  10EMA) 50SMA;  ,  21EMA         |
//|     -0,1..0,1;      |
//|   21EMA  10EMA    .                  |
//|    (   - |
//|   ):                                          |
//| 1)    10EMA     |
//|        50SMA  ,   |
//|    ,      - |
//|  ,    ;                   |
//| 2)  ,  1,    ( )      |
//|   N  ;  1,        .;|
//| 3)     ;                            |
//| 4) ""  (  );            |
//| 5)  .                                               |
//|     6 . + ;   ..  +6 .   |
//| (..    6 . + ;  10 . + .    |
//|       21EMA, -  |
//|    .                                      |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
   {
   if ((iSl<1) || (iTP<1) || (iToBE>=iTP) || (iToBE<=MarketInfo(Symbol(),MODE_STOPLEVEL)) || (iSMA50Diff<2) 
   || (dAngleMACritical<10) || (iIndent<0))
      {
      Print("StopLoss (",iSl,") or TakeProfit (",iTP,") are incorrect. Expert 5min.ex4 is stopped.");   
      return(0);  
      }   
   return(0);
   }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
   {   
   int n, i; // 
   int iOpenTradesN = 0; // -     
   int iPendingTradesN = 0; // -     
   double dBid, dAsk; //     
   double dToOpen = 0; //   (  )
   double dMA50a = 0; // SMA50   1 (     )
   double dMA50b = 0; // 
   double dEMA21 = 0; //    21
   double dEMA10 = 0; //    10
   double dSMA50Angle = 0; //   SMA50
   string s2ndCurr = 0; //      
   double dMultiply = 0; //      
   double dAngleValSum = 0; //  21    SMA50 (  )
   double dEMA21Angle = 0; // 21     SMA50   
   double dOpenPrice = 0; //    
   
   //    ,  
   for (i=0;i<OrdersTotal();i++)
      {
      if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) break;
      if (OrderMagicNumber()!=magic || OrderSymbol()!=Symbol()) continue;
      if (OrderType()==OP_BUY)                  
         {         
         // *    ,    
         if ((OrderStopLoss()==0) || (OrderTakeProfit()==0))
            {        
            if (!OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-(iSl+MarketInfo(OrderSymbol(),MODE_SPREAD))*Point,OrderOpenPrice()+(iTP+MarketInfo(OrderSymbol(),MODE_SPREAD))*Point,OrderExpiration(),Red))
               {
               Print("Failed to set stoploss and takeprofit of position #",OrderTicket(),". Err: ",GetLastError());                       
               Comment("Failed to set stoploss and takeprofit of position #",OrderTicket(),". Err: ",GetLastError());                       
               }
            }
                  
         // *     +6 .
         dBid = MarketInfo(OrderSymbol(),MODE_BID);
         if (dBid - OrderOpenPrice()>=(iToBE + MarketInfo(OrderSymbol(),MODE_SPREAD))*Point)
            {
            if (OrderStopLoss()!=OrderOpenPrice())
               {
               if (!OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),OrderExpiration(),Red))
                  {
                  Print("Failed to move stoploss of position #",OrderTicket()," to breakeven. Err: ",GetLastError());
                  Comment("Failed to move stoploss of position #",OrderTicket()," to breakeven. Err: ",GetLastError());
                  }
               }
            }
         
         // *     ,    21EMA,    
         if (OrderStopLoss()!=OrderOpenPrice())
            {
            dEMA21 = iMA(OrderSymbol(),0,21,0,MODE_EMA,PRICE_CLOSE,0);
            if (dBid<=dEMA21)
               {               
               if (OrderTakeProfit()!=OrderOpenPrice())
                  {
                  if (!OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),OrderOpenPrice(),OrderExpiration(),Red))
                     {
                     Print("Failed to move takeprofit of position #",OrderTicket()," to breakeven. Err: ",GetLastError());
                     Comment("Failed to move takeprofit of position #",OrderTicket()," to breakeven. Err: ",GetLastError());
                     }
                  }
               }
            }
         //   
         iOpenTradesN++;         
         }
         
      if (OrderType()==OP_SELL)                  
         {         
         // *    ,    
         if ((OrderStopLoss()==0) || (OrderTakeProfit()==0))
            {        
            if (!OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+(iSl+MarketInfo(OrderSymbol(),MODE_SPREAD))*Point,OrderOpenPrice()-(iTP+MarketInfo(OrderSymbol(),MODE_SPREAD))*Point,OrderExpiration(),Blue))
               {
               Print("Failed to set stoploss and takeprofit of position #",OrderTicket(),". Err: ",GetLastError());                       
               Comment("Failed to set stoploss and takeprofit of position #",OrderTicket(),". Err: ",GetLastError());                       
               }
            }
                  
         // *     +6 .
         dAsk = MarketInfo(OrderSymbol(),MODE_ASK);
         if (OrderOpenPrice() - dAsk>=(iToBE + MarketInfo(OrderSymbol(),MODE_SPREAD))*Point)
            {
            if (OrderStopLoss()!=OrderOpenPrice())
               {
               if (!OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),OrderExpiration(),Blue))
                  {
                  Print("Failed to move stoploss of position #",OrderTicket()," to breakeven. Err: ",GetLastError());
                  Comment("Failed to move stoploss of position #",OrderTicket()," to breakeven. Err: ",GetLastError());
                  }
               }
            }
         
         // *     ,    21EMA,    
         if (OrderStopLoss()!=OrderOpenPrice())
            {
            dEMA21 = iMA(OrderSymbol(),0,21,0,MODE_EMA,PRICE_CLOSE,0);
            if (dAsk>=dEMA21)
               {               
               if (OrderTakeProfit()!=OrderOpenPrice())
                  {
                  if (!OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),OrderOpenPrice(),OrderExpiration(),Blue))
                     {
                     Print("Failed to move takeprofit of position #",OrderTicket()," to breakeven. Err: ",GetLastError());
                     Comment("Failed to move takeprofit of position #",OrderTicket()," to breakeven. Err: ",GetLastError());
                     }
                  }
               }
            } 
         //   
         iOpenTradesN++;                    
         }                                                           
      }
   
   //    ,     
   if (iOpenTradesN==0)         
      {
      for (i=1;i<22;i++)
         {
         //   21   -   SMA50
         //    SMA50       iSMA50Diff  
         //     : )  SMA50     ([1]); )  SMA50
         // iSMA50Diff  ; )  iSMA50Diff
         dMA50a = iMA(Symbol(),0,50,0,MODE_SMA,PRICE_CLOSE,i);
         dMA50b = iMA(Symbol(),0,50,0,MODE_SMA,PRICE_CLOSE,i+iSMA50Diff);  
         //   100       10000 -  
         s2ndCurr = StringSubstr(Symbol(),3,3);
         if (s2ndCurr=="JPY") dMultiply = 100.0;
         else dMultiply = 10000; 
         if (dMA50a!=dMA50b)
            {
            if (dMA50a>dMA50b) 
            dSMA50Angle = MathArctan((dMA50a-dMA50b)/iSMA50Diff*(180.0/3.14159))*dMultiply;   
            if (dMA50a<dMA50b) 
            dSMA50Angle = MathArctan(MathAbs(dMA50a-dMA50b)/iSMA50Diff*(180.0/3.14159))*dMultiply*(-1);               
            //    
            dAngleValSum += dSMA50Angle;
            }
         }
      //   21- ()       SMA50
      dEMA21Angle = dAngleValSum / 21;
      
      Print("dEMA21Angle: ",dEMA21Angle);
      
      //  SMA21   SMA50 -     +/- dEMA21Angle , 
      if ((dEMA21Angle>dAngleMACritical) || (dEMA21Angle<dAngleMACritical*(-1)))
         {
         //  ,  EMA21  EMA10  SMA50    , 
         //   EMA10   EMA21  (  : - - 
         // SMA50 - EMA21 - EMA10 - 
         dMA50a = iMA(Symbol(),0,50,0,MODE_SMA,PRICE_CLOSE,1);
         dEMA21 = iMA(Symbol(),0,21,0,MODE_EMA,PRICE_CLOSE,1);
         dEMA10 = iMA(Symbol(),0,10,0,MODE_EMA,PRICE_CLOSE,1);
         
         //   
         if (dEMA21Angle>dAngleMACritical)
            {             
            if ((dEMA21>dMA50a) && (dEMA10>dEMA21))
               {            
               Comment("Waiting for the buy situation.");
               Print("Waiting for the buy situation.");
            
               //   -  (  )
               //    
               for (i=0;i<OrdersTotal();i++)
                  {
                  if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) break;
                  if (OrderMagicNumber()!=magic || OrderSymbol()!=Symbol()) continue;
                  if (OrderType()==OP_SELLSTOP)                  
                     {   
                     if (!OrderDelete(OrderTicket()))
                        {
                        Comment("Failed to delete sell stop order.");
                        Print("Failed to delete sell stop order.");
                        }
                     }
                  if (OrderType()==OP_SELL)                  
                     {
                     dAsk = MarketInfo(OrderSymbol(),MODE_ASK);   
                     if(!OrderClose(OrderTicket(),OrderLots(),dAsk,3,Blue))
                        {
                        Comment("Failed to close short position.");
                        Print("Failed to close short position.");
                        }
                     }                  
                  }
            
               //      dEMA10,              
               dBid = MarketInfo(OrderSymbol(),MODE_BID);
               if (Low[1]<=dEMA10)
                  {
                  //     [1]    iIndent 
                  //  ,   
                  for (i=0;i<OrdersTotal();i++)
                     {
                     if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) break;
                     if (OrderMagicNumber()!=magic || OrderSymbol()!=Symbol()) continue;
                     if (OrderType()==OP_BUYSTOP)                  
                        {  
                        //  , ,       ,  high[1]+iIndent+
                        dOpenPrice = High[1] + (iIndent + MarketInfo(Symbol(),MODE_SPREAD))*Point; 
                        if (OrderOpenPrice()>dOpenPrice) 
                           {
                           //  ,   
                           if (!OrderModify(OrderTicket(),dOpenPrice,dOpenPrice-(iSl+MarketInfo(OrderSymbol(),MODE_SPREAD))*Point,dOpenPrice+(iTP+MarketInfo(OrderSymbol(),MODE_SPREAD))*Point,0,Red))
                              {
                              Comment("Failed to modify order #",OrderTicket()," open price. Err.: ",GetLastError());
                              Print("Failed to modify order #",OrderTicket()," open price. Err.: ",GetLastError());
                              }
                           }                     
                        iPendingTradesN++;
                        }
                     }                                             
                  //   - , 
                  if (iPendingTradesN==0)
                     {
                     dOpenPrice = High[1] + (iIndent + MarketInfo(Symbol(),MODE_SPREAD))*Point; 
                     if (OrderSend(Symbol(),OP_BUYSTOP,dLot,dOpenPrice,3,dOpenPrice-(iSl+MarketInfo(Symbol(),MODE_SPREAD))*Point,dOpenPrice+(iTP+MarketInfo(Symbol(),MODE_SPREAD))*Point,NULL,magic,0,Red)<0)
                        {
                        Comment("Failed to set buy stop order. Err.: ",GetLastError());
                        Print("Failed to set buy stop order. Err.: ",GetLastError());                     
                        }
                     Print("dOpenPrice: ",dOpenPrice,", SL: ",dOpenPrice-(iSl+MarketInfo(Symbol(),MODE_SPREAD))*Point);
                     }
                  }
               }
            }
            
         //   
         if (dEMA21Angle<dAngleMACritical)
            {
            if ((dEMA21<dMA50a) && (dEMA10<dEMA21))
               {            
               Comment("Waiting for the sell situation.");
               Print("Waiting for the sell situation.");
            
               //   buy-  (  )
               for (i=0;i<OrdersTotal();i++)
                  {
                  if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) break;
                  if (OrderMagicNumber()!=magic || OrderSymbol()!=Symbol()) continue;
                  if (OrderType()==OP_BUYSTOP)                  
                     {   
                     if (!OrderDelete(OrderTicket()))
                        {
                        Comment("Failed to delete buy stop order.");
                        Print("Failed to delete buy stop order.");
                        }
                     }
                  if (OrderType()==OP_BUY)                  
                     {
                     dBid = MarketInfo(OrderSymbol(),MODE_BID);   
                     if(!OrderClose(OrderTicket(),OrderLots(),dBid,3,Red))
                        {
                        Comment("Failed to close long position.");
                        Print("Failed to close long position.");
                        }
                     }                    
                  }            
            
               //      dEMA10,   low    
               dBid = MarketInfo(OrderSymbol(),MODE_BID);
               if (High[1]>=dEMA10)
                  {
                  //  sell stop  low[1]    iIndent 
                  //  ,  sell stop
                  for (i=0;i<OrdersTotal();i++)
                     {
                     if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) break;
                     if (OrderMagicNumber()!=magic || OrderSymbol()!=Symbol()) continue;
                     if (OrderType()==OP_SELLSTOP)                  
                        {  
                        //  , ,       ,  high[1]+iIndent+
                        dOpenPrice = Low[1] - (iIndent + MarketInfo(Symbol(),MODE_SPREAD))*Point; 
                        if (OrderOpenPrice()<dOpenPrice) 
                           {
                           //  ,   
                           if (!OrderModify(OrderTicket(),dOpenPrice,dOpenPrice+(iSl+MarketInfo(OrderSymbol(),MODE_SPREAD))*Point,dOpenPrice-(iTP+MarketInfo(OrderSymbol(),MODE_SPREAD))*Point,0,Blue))
                              {
                              Comment("Failed to modify order #",OrderTicket()," open price. Err.: ",GetLastError());
                              Print("Failed to modify order #",OrderTicket()," open price. Err.: ",GetLastError());
                              }                        
                           }
                        iPendingTradesN++;
                        }
                     }                                             
                  //  sell stop- , 
                  if (iPendingTradesN==0)
                     {
                     dOpenPrice = Low[1] - (iIndent + MarketInfo(Symbol(),MODE_SPREAD))*Point; 
                     if (OrderSend(Symbol(),OP_SELLSTOP,dLot,dOpenPrice,3,dOpenPrice+(iSl+MarketInfo(Symbol(),MODE_SPREAD))*Point,dOpenPrice-(iTP+MarketInfo(Symbol(),MODE_SPREAD))*Point,NULL,magic,0,Blue)<0)
                        {
                        Comment("Failed to set sell stop order. Err.: ",GetLastError());
                        Print("Failed to set sell stop order. Err.: ",GetLastError());                     
                        }
                     }
                  }            
               }                                    
            }
         }
      }                      
   return(0);
   }
//+------------------------------------------------------------------+


//http://www.forexfactory.com/showthread.php?t=11854&page=35